### Name: Cholesky
### Title: Cholesky Decomposition of a Sparse Matrix
### Aliases: Cholesky Cholesky,dsCMatrix-method
### Keywords: array algebra

### ** Examples

data(KNex)
mtm <- with(KNex, crossprod(mm))
str(mtm@factors) # empty list()
Cholesky(mtm)             # uses show(<MatrixFactorization>)
str(mtm@factors) # 'sPDCholesky' (simpl)
(Cm <- Cholesky(mtm, super = TRUE))
str(mtm@factors) # 'sPDCholesky'  *and*  'SPDCholesky'
str(cmat <- as(Cm, "sparseMatrix"))
cmat[1:20, 1:20]
b <- matrix(c(rep(0, 711), 1), nc = 1)
## solve(Cm, b) by default solves  Ax = b, where A = Cm'Cm !
stopifnot(identical(solve(Cm, b), solve(Cm, b, system = "A")),
          all.equal(solve(mtm, b),
                    solve(Cm, b)))



