### Name: Schur
### Title: Schur Decomposition of a Matrix
### Aliases: Schur Schur,dgeMatrix,logical-method
###   Schur,dgeMatrix,missing-method Schur,ddenseMatrix,logical-method
###   Schur,ddenseMatrix,missing-method
### Keywords: algebra

### ** Examples

Schur(Hilbert(9))              # Schur factorization (real eigenvalues)

(A <- Matrix(round(rnorm(5*5, sd = 100)), nrow = 5))
(Sch.A <- Schur(A))
## The 'WR' and 'WI' components:
eTA <- eigen(Sch.A$T)
stopifnot(all.equal(eTA$values, eigen(A)$values, tol = 1e-13),
          all.equal(eTA$values,
                    local({z <- with(Sch.A, WR + 1i* WI)
                           z[order(Mod(z), decreasing=TRUE)]}), tol = 1e-13))



